#ifndef _JRTPLIB_SRTP_H_
#define _JRTPLIB_SRTP_H_

#include <stdint.h>
#include <sys/types.h>


namespace jrtplib
{

class SRTPEncryptor {
public:
	enum PacketType { RTP, RTCP };
	
	virtual ~SRTPEncryptor() { }
	
	virtual int Encrypt(uint8_t *packet, size_t packetLength, PacketType packetType = RTP) = 0;
	virtual uint8_t * GetEncryptedPacket(void) = 0;
	virtual size_t GetEncryptedPacketLength() = 0;
};

class SRTPDecryptor {
public:
	enum PacketType { RTP, RTCP };
	
	virtual ~SRTPDecryptor() { }

	// RTCP decryption will be done in place (decrypted data will be put in same buffer and new size will be returned by GetDecryptedPacketLength)
	virtual int Decrypt(uint8_t *packet, size_t packetLength, PacketType packetType = RTP) = 0;
	virtual uint8_t * GetDecryptedPacket(void) = 0; // for RTP only
	virtual size_t GetDecryptedPacketLength() = 0; // for RTP and RTCP
};

} //  namespace jrtplib



extern jrtplib::SRTPDecryptor *g_VideoServiceRtcpDecryptor;
extern jrtplib::SRTPEncryptor *g_VideoServiceRtcpEncryptor;

#endif // _JRTPLIB_SRTP_H_
